/**********************************************************************
 * This file is part of FMR (Fast Machine Reassignment)               
 *                                                                   
 * ROADEF/EURO Challenge 2012: Machine Reassignment                 
 * http://challenge.roadef.org/2012/en/				   
 * Team S26
 *     
 * Copyright (C) 2011-12 Laboratoire d'Informatique de Paris Nord 
 * UMR CNRS 7030 
 * Institut Galilée - Université Paris-Nord
 * 99, avenue Jean-Baptiste Clément 
 * 93430 Villetaneuse  
 *        
 * FMR is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *  
 * FMR is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *  
 * You should have received a copy of the GNU General Public License
 * along with FMR; if not, write to the Free Software Foundation,
 * Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 **********************************************************************/
#ifndef fmr_constraints
# define fmr_constraints 1

#include "fmr.h"

bool verifU(placement_t*, unsigned int);
bool check_remove_proc (unsigned int , unsigned int , placement_t * );
bool check_add_proc (const placement_t const *, unsigned int , unsigned int , placement_t *);

bool capacity_constraint(placement_t*);
bool capacity_constraint_shift(placement_t*, unsigned int, unsigned int, unsigned int);
bool capacity_constraint_swap(placement_t*, unsigned int, unsigned int, unsigned int, unsigned int);
bool conflicts_constraint(placement_t*);
bool conflicts_constraint_shift(placement_t*, unsigned int, unsigned int);
bool conflicts_constraint_swap(placement_t*, unsigned int, unsigned int, unsigned int, unsigned int);
bool dependancy_constaint(placement_t *);
bool dependancy_constaint_shift(placement_t *,unsigned int, unsigned int, unsigned int);
bool dependancy_constaint_swap(placement_t *,unsigned int, unsigned int, unsigned int,unsigned int);
bool transient_constraint(const placement_t *, placement_t *);
bool transient_constraint_shift(placement_t *, placement_t *,unsigned int, unsigned int, unsigned int);
bool spread_constraint(placement_t *);
bool spread_constraint_shift(placement_t *, unsigned int, unsigned int, unsigned int);
bool spread_constraint_swap(placement_t *, unsigned int, unsigned int, unsigned int, unsigned int);
bool check_all_constraints(const placement_t const *, placement_t *);
bool check_all_constraints_shift(placement_t *, unsigned int, unsigned int, unsigned int);
bool check_all_constraints_swap(placement_t *, unsigned int, unsigned int, unsigned int, unsigned int);

bool check_add_proc_glouton (const placement_t const *, unsigned int p, unsigned int m, placement_t * );
bool check_add_proc_glouton2 (const placement_t const *, unsigned int p, unsigned int m, placement_t * );

#endif
