/**********************************************************************
 * This file is part of FMR (Fast Machine Reassignment)               
 *                                                                   
 * ROADEF/EURO Challenge 2012: Machine Reassignment                 
 * http://challenge.roadef.org/2012/en/				   
 * Team S26
 *     
 * Copyright (C) 2011-12 Laboratoire d'Informatique de Paris Nord 
 * UMR CNRS 7030 
 * Institut Galilée - Université Paris-Nord
 * 99, avenue Jean-Baptiste Clément 
 * 93430 Villetaneuse  
 *        
 * FMR is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *  
 * FMR is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *  
 * You should have received a copy of the GNU General Public License
 * along with FMR; if not, write to the Free Software Foundation,
 * Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 **********************************************************************/
#ifndef _fmr_threads_h_
#define _fmr_threads_h_

#include "fmr.h"

#include <pthread.h>



void
atomic_init_meilleur_placement();

int64_t
atomic_get_meilleur_cout();

/// récupère un pointeur sur le meilleur placement
placement_t *
atomic_get_meilleur_placement() ;

/// copie proposition dans le meilleur placement si elle est meilleure
void
atomic_set_meilleur_placement(placement_t * proposition, char algo);

/// copie le meilleur placement dans proposition s'il est meilleur
void
atomic_if_meilleur_placement_copyto(placement_t * proposition);

void
atomic_free_placement();

void
atomic_lock_placement();

void
atomic_unlock_placement();

#endif
